import { Nullable } from '@salesforce/ts-types';
import { NamedPackageDir } from '@salesforce/core';
import { Deployable, Deployer, Preferences, DeployerOptions } from '@salesforce/plugin-deploy-retrieve-utils';
import { TestLevel } from './testLevel';
export interface MetadataDeployOptions extends DeployerOptions {
    testLevel?: TestLevel;
    username?: string;
    directories?: string[];
}
export declare class DeployablePackage extends Deployable {
    pkg: NamedPackageDir;
    private parent;
    constructor(pkg: NamedPackageDir, parent: Deployer);
    getAppName(): string;
    getAppType(): string;
    getAppPath(): string;
    getEnvType(): Nullable<string>;
    getParent(): Deployer;
}
export declare class MetadataDeployer extends Deployer {
    private packages;
    static NAME: string;
    deployables: DeployablePackage[];
    private testLevel;
    private username;
    constructor(packages: NamedPackageDir[]);
    getName(): string;
    setup(preferences: Preferences, options: MetadataDeployOptions): Promise<MetadataDeployOptions>;
    deploy(): Promise<void>;
    promptForUsername(): Promise<string>;
    promptForTestLevel(): Promise<TestLevel>;
}
